#!/bin/bash

exec > /tmp/checkupdate.log

check_presence() {
    echo "Verifying content of archive."

    archive="${1}"
    files="\
        1730_firmware/update/README \
        1730_firmware/update/checkupdate.sh \
        1730_firmware/update/checkversion.sh \
        1730_firmware/update/prepare.sh \
        1730_firmware/update/u-boot_env-prepare.txt \
        1730_firmware/update/uKernel \
        1730_firmware/update/uRamFS \
        1730_firmware/firmware/uBoot \
        1730_firmware/firmware/uKernel \
        1730_firmware/firmware/uRootFS \
        1730_firmware/firmware/uSplash \
    "
    archive_content=$(/usr/bin/unzip -l ${archive})

    for f in ${files}; do
        if ! echo ${archive_content} | grep -q ${f}; then
            echo "Presence check for ${f} failed!"
            return -1
        fi
    done

    return 0
}

echo "Running pre-update checks..."

if ! check_presence "${1}"; then
    exit -1
fi

# return 0 if update process may proceed,
# else if update must be aborted
exit 0

