#! /bin/sh

set -e

UPDATE_PREPARE_UBOOT_ENV=/var/lib/joule/1730_firmware/update/u-boot_env-prepare.txt
CHECKVERSION=/var/lib/joule/1730_firmware/update/checkversion.sh
README_CURR=/usr/share/joule/README
README_UPDATE=/var/lib/joule/1730_firmware/update/README
LOGFILE=/var/lib/joule/log/fw_update.log
LOGFILE_TEMP=/var/lib/joule/log/fw_update.tmp

# Logging (will be finalised by /sbin/init after update)
echo $(/bin/date +"%Y-%m-%d %H:%M:%S") $(/bin/date -u +"UTC:%H:%M") Starting firmware update from version \
$($CHECKVERSION -d $README_CURR) \
to $($CHECKVERSION -d $README_UPDATE) >> $LOGFILE
echo 1 > $LOGFILE_TEMP

make_fw_env_config() {
    /bin/busybox awk \
        "/u-boot_env/ { s=\$2; e=\$3; split(\$1, m, \":\"); printf(\"/dev/%s 0x0 0x%d 0x%d\\n\", m[1], s, e); }" \
        < /proc/mtd \
        > /etc/fw_env.config
}

echo "Adjusting u-boot environment..."
make_fw_env_config
/sbin/fw_setenv -s ${UPDATE_PREPARE_UBOOT_ENV}

echo "Storing firmware package name into u-boot environment..."
/sbin/fw_setenv "fw_file" "${1}"

echo "Backup system settings..."
echo "...to be done..."

echo "Synchronizing file system..."
/bin/sync

echo "Rebooting..."
/sbin/shutdown -r now
